// protect.c

#include "protect.h"

void		 EnProtect(char *string,int strlen,int BIT_NUM,int BYTE_NUM)
{
	int i = 0 ; 
	for(i = 0 ; i < strlen ; i++)
		Shift_Bit_Right(&string[i],BIT_NUM);
	for(i = 0 ; i < strlen ; )
	{
		Shift_Byte_Right(&string[i],4 ,BYTE_NUM);
		i += 4 ; 
	}

}

void		 DeProtect(char *string,int strlen,int BIT_NUM,int BYTE_NUM)
{
	int i = 0 ; 
	for(i = 0 ; i < strlen ; )
	{
		Shift_Byte_Left(&string[i],4 ,BYTE_NUM);
		i += 4 ; 
	}
	for(i = 0 ; i < strlen ; i++)
		Shift_Bit_Left(&string[i],BIT_NUM);
}

void		test(char *string)
{
	int i = 0 ; 
	for(; string[i] !='\0' ; i++)
		printf("%c",string[i]);
	
	printf("\n");

	
}


void 		Shift_Byte_Left(char* string,int index,  int BYTE_NUM)
{
	unsigned int target = 0 ,temp; 
	int i  ; 
	unsigned int value = -1; 
	for(i = 0 ; i < index ; i++)
	{
		temp =(unsigned int) string[i] ; 
		temp = temp & 0x000000ff ; 
		target = temp | target ;
		if(index-1 != i)
			target <<= 8 ; 
	}	
	value  ^= target ; 
	target ^= value ; 
	
	// value = Shuffle(value,32-BYTE_NUM);
	for(;  index >= 1  ; index--) // index ==3 ... 
	{
		string[index-1] = (char)value;  
		value >>= 8 ;
	}	
}

void 		Shift_Byte_Right(char* string, int index,  int BYTE_NUM) // 4Byte ... bit chage ; 
{
	unsigned int value = -1 ; 
	unsigned int target = 0 , temp = 0 ; 
	int i  ;
	for(i = 0 ; i < index ; i++)
	{
		temp = (unsigned int)string[i] ; 
		temp = temp & 0x000000ff ; 
		target = temp | target ;
		if(index-1 >i)
		{	target <<= 8 ; 
		
		}	
	}
	//target = Shuffle(target , BYTE_NUM);
	target ^=  value; 
	
	for(  ;  index >= 1  ; index--) // index ==3 ...
	{
		string[index-1] = (char)target ; 
		target >>= 8 ;
		
	}
}


void		Show_Bit_2_Char(char ch)
{ 
	unsigned int target = 0x80;
	int	 j = 0 ; 
	int 	bit_size = sizeof(char) * 8 ; 
		
	for (j=0; j<bit_size; j++)
	{	
		if ((ch & target) == 0)
			putchar('0');
		else
			putchar('1');

		target >>= 1;
	}

}

void	show(unsigned int ch )
{

	int i  ; 
	unsigned	int 	target =0 ; 
	int	bit_size = 32 ; 
	target = 0x80000000;

	for (i=0; i<bit_size; i++)
	{
		if ((ch & target) == 0)
			putchar('0');
		else
			putchar('1');

		target >>= 1;
	}

	putchar('\n');
}

void 		Shift_Bit_Left(char* ch , int BIT_NUM) 
{
	int i ; 

	char 	msb , lsb , msb2; 
	msb = 0x80;
	lsb = 0x01 ; 
	msb2 = 0x7f ; 
	

	for(i =0 ; i < BIT_NUM ; i++)
	{
		if( (*ch & msb) == 0 )
		{	
			*ch = *ch << 1 ; 
		}
		else
		{	
			*ch = *ch << 1 ; 
			*ch = *ch | lsb ; 
		}

	}
}

void 		Shift_Bit_Right(char* ch , int BIT_NUM) 
{
	int i ; 
	char 	msb , lsb , msb2; 
	msb 	= 0x80;
	lsb 	= 0x01 ; 
	msb2 	= 0x7f ; 

	for(i =0 ; i < BIT_NUM ; i++)
	{
		if( (*ch & lsb) == 0 )
		{	*ch = *ch >> 1 ; 
		*ch = *ch & msb2 ; 
		}
		else
		{	
			*ch = *ch >> 1 ; 
			*ch = *ch | msb ; 
		}

	}	

}
unsigned 	int		Shuffle(unsigned int target, unsigned int changeBit )
{
	unsigned    int 	i = 0, num = target; 
	unsigned	int     bit = 0x00000001, temp; 
	for (i=0; i< changeBit; i++)  
	{
		target = target >> 1;
		
		if (target > 0)
		{
			if ((num & bit) == 0)
				target = target | (int) 0;
			else
			{
				temp = 0x80000000;
				target = target | temp;
			}
		}
		else
		{
			if ((num & bit) == 0)
			{
				temp = 0x7FFFFFFF;
				target = target & temp;
			}
			else
			{
				temp = 0xFFFFFFFF;
				target = target & temp;
			}
		}
		bit = bit << 1;
	}
	return target ; 
}


